#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <map>

using namespace std;

void loadAndParseData(ifstream& in, multimap<char, string>& dict) {
	string word;
	
	while (getline(in, word)) {
		char firstCharacter = word[0];

		dict.emplace(firstCharacter, word);
	}

	in.close();
}

void checkUserInput(multimap<char, string>& dict) {
	bool input;

	do {
		char inputCharacter;
		cout << "Which character do you want to check?: ";
		cin >> inputCharacter;

		inputCharacter = tolower(inputCharacter);

		auto location = dict.find(inputCharacter);
		if (location == dict.end()) {
			cout << "Invalid input!" << endl;
		}
		else {
			for (auto it = location; it != dict.end(); ++it) {
				char firstChar = it->first;
				if (firstChar != inputCharacter) break;

				string word = it->second;
				cout << word << endl;
			}
		}

		cout << "Another one? (1-Y, 0-N): ";
		cin >> input;
	} while (input);
}

int main() {
	ifstream in("nounlist.csv");
	if (!in) {
		cout << "404" << endl;
		return 1;
	}

	multimap<char, string> dict;

	loadAndParseData(in, dict);

	checkUserInput(dict);

	return 0;
}